<?PHP
////////////////////////////////////////////////////////////////////////////////////////////
//+--------------------------------------------------------------------------------------+//
//| file : allmyphp_functions.inc.php                                                    |//
//| project : AllMyPHP Function libary                                                   |//
//| last modified : 12.01.2003                                                           |//
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+//
//|                                                                                      |//
//| voice of web function libary                                                         |//
//| Please read the licence document, these functions are not                            |//
//| "public domain software" or freeware and you are not able to use it on other projects|//
//| without buying a regular licence!                                                    |//
//|                                                                                      |//
//+--------------------------------------------------------------------------------------+//
//| (c) 2003 by AllMyPHP                                                                 |//
//| This file is part of the "AllMyPHP Project", http://www.php-resource.net             |//
//| The "AllMyPHP Project" is part of voice of web, http://www.voice-of-web.de           |//
//| All rights reserved!                                                                 |//
//+--------------------------------------------------------------------------------------+//
////////////////////////////////////////////////////////////////////////////////////////////


//+----------------------------------------------------------------------------------------+
//| function : AMP_cut_string                                                    	   |
//| last modified: 28.05.2004                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| using substr to cut string to specific length                                          |
//| added " ..."                                                                           |
//|                                                                                        |
//| $AMP_string = string to cut                                                            |
//| $AMP_count  = length                                                                   |
//|----------------------------------------------------------------------------------------|
//| AMP_mask_ipadr ( VARCHAR, INT )                                                        |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_cut_string'))
{
	function AMP_cut_string($AMP_string, $AMP_count)
	{
		if(!empty($AMP_string) && is_numeric($AMP_count))
		{
			$AMV_stringlengh = strlen($AMP_string);
			if($AMV_stringlengh > $AMP_count)
			{
				$AMP_return = substr($AMP_string, 0, $AMP_count);
				$AMP_return = $AMP_return." ...";
			}
			else
			{
				$AMP_return = $AMP_string;
			}
		}
		else
		{
			$AMP_return = "\$AMP_string or \$AMP_count NOT SET in AMP_cut_string";
		}
		return $AMP_return;
	}
}


//+----------------------------------------------------------------------------------------+
//| function : AMP_mask_ipadr                                                    	   |
//| last modified: 28.05.2004                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| mask existing IP adress due to privacy reasons                                         |
//|                                                                                        |
//| $AMP_ipadr = contains ip                                                               |
//| $AMP_type  = contains type : 0 = no masking                                            |
//|                              1 = masking last number                                   |
//|                              2 = masking last two numbers                              |
//|                              3 = masking last three numbers                            |
//|                              4 = replace IP to "[blocked]"                             |
//|                              - = default ($AMP_type not set) is 4                      |
//|----------------------------------------------------------------------------------------|
//| AMP_mask_ipadr ( IPADR, INT[0,1,2,3,4] )                                               |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_mask_ipadr'))
{
	function AMP_mask_ipadr($AMP_ipadr, $AMP_type)
	{
		if(isset($AMP_type)  && is_numeric($AMP_type))
		{
			if($AMP_type == '0'){
				$AMP_return = $AMP_ipadr;
			} 
			elseif($AMP_type == '1'){
				$AMP_pieces = explode(".", $AMP_ipadr);
				$AMP_return = $AMP_pieces['0'].".".$AMP_pieces['1'].".".$AMP_pieces['2']."*";
			} 
			elseif($AMP_type == '2'){
				$AMP_pieces = explode(".", $AMP_ipadr);
				$AMP_return = $AMP_pieces['0'].".".$AMP_pieces['1'].".*.*";		
			} 
			elseif($AMP_type == '3'){
				$AMP_pieces = explode(".", $AMP_ipadr);
				$AMP_return = $AMP_pieces['0'].".*.*.*";
			} 
			elseif($AMP_type == '4'){
				$AMP_return = "[blocked]";
			}
		}
		else
		{
			$AMP_ipadr = "[blocked]";
		}
		
		
		return $AMP_return;
	}	
}


//+----------------------------------------------------------------------------------------+
//| function : AMP_smilie_replace                                                    	   |
//| last modified: 12.01.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| replace dummy smilie code with html img tags to display smilies			   |
//| using this function will be only possible if 'string1' is filled with smiliecode       |
//| created from function AMP_smilie_add and uses the same 'string2' and 'string3'         |
//|                                                                                        |
//| string1 = String where the smiliecode exists and need to be replaced with image tags   |
//| string2 = directory where the smilies are stored                                       |
//| string3 = accessible url to smilie directory                                           |
//| integer = true or false; true will change the smilie code with images, false returns   |
//|           the string without any smilie code and without any smilie image              |
//|-------------------------------------------------------------------------------------- -|
//| AMP_smilie_replace ( string1, string2, string3, integer[0,1] )                         |
//+----------------------------------------------------------------------------------------+

if(!function_exists('AMP_smilie_replace'))
{
	function AMP_smilie_replace($AMP_string, $AMP_dir, $AMP_url, $AMP_smilie_allow)
	{
		$AMP_chdir = @chdir("$AMP_dir"); 
		if($AMP_chdir){
			$AMP_opendir=opendir('.');
	
			while (false !== ($AMP_smilies = readdir ($AMP_opendir))) {
			
				if ($AMP_smilies != "." && $AMP_smilies != "..") {
					$AMP_smiliestring = explode(".gif", $AMP_smilies);
					if($AMP_smilie_allow == '1'){  
						$AMP_string = str_replace(":$AMP_smiliestring[0]:", "<img align=\"absmiddle\" src=\"$AMP_url/$AMP_smilies\" border=\"0\">", $AMP_string);
			        	} 
			        	else 
			        	{
						$AMP_string = str_replace(":$AMP_smiliestring[0]:", "", $AMP_string);
			        	}	
				}
			
			}
			closedir($AMP_opendir); 
		} 
		else 
		{
			echo "<b><font color=\"red\">Error, could not open \"$AMP_dir\" for reading in function <i>AMP_smilie_replace</i>. process stopped!</font></b>";
			exit;
		}
		return $AMP_string;
	}
}
//+--------------------------------------------------------------------------------------+
//| function : AMP_setlanguage                                                	 	 |
//| last modified: 12.01.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| gets the current working language		 					 |
//| make use of user configurations in further versions                                  |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_setlanguage'))
{
	function AMP_setlanguage($AMP_path, $AMP_language)
	{
		global $HTTP_COOKIE_VARS;
	
		include("$AMP_path/"."$AMP_language/$AMP_language".".lang.php");
		return($_AMLlanguage);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_settemplate	                                               	         |
//| last modified: 12.01.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| gets the active template			 					 |
//| make use of user configurations in further versions                                  |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_settemplate'))
{
	function AMP_settemplate($AMP_template)
	{
		global $HTTP_COOKIE_VARS;
	
		$AMP_template = $AMP_template;
		
		return($AMP_template);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_setdate	                                                	 |
//| last modified: 12.01.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| gives all timeflags the right date to display			 		 |
//| make use of user configurations in further versions                                  |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_setdate'))
{
	function AMP_setdate($AMP_dateformat, $AMP_countflag, $AMP_timezone)
	{
		return gmdate($AMP_dateformat, $AMP_countflag + (3600 * $AMP_timezone));
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_month_getfirstday                                          	         |
//| last modified: 25.07.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| returns the first day of a specified month                                           |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_month_getfirstday'))
{
	function AMP_month_getfirstday($AMP_year,$AMP_month)
	{
		settype($AMP_return,'array');
		$AMP_day = '1';
		$AMP_date = "$AMP_year-$AMP_month-$AMP_day";
		$AMP_firstday = strtotime($AMP_date);
		$AMP_return['w']  = date("w",$AMP_firstday);
		$AMP_return['W']  = date("W",$AMP_firstday);
		return($AMP_return);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_month_getlastday                                          	         |
//| last modified: 25.07.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| returns the last day of a specified month                                            |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_month_getlastday'))
{
	function AMP_month_getlastday($AMP_year,$AMP_month)
	{
		settype($AMP_return,'array');
		$AMP_day = '1';
		$AMP_date = "$AMP_year-$AMP_month-$AMP_day";
		$AMP_firstday = strtotime($AMP_date);
		$AMP_lastday = $AMP_firstday + 2678400;
		do 
		{
			$AMP_lastday = $AMP_lastday - 86400;
		} 
		while (date("m",$AMP_lastday) != $AMP_month);
		$AMP_return['j'] = date("j",$AMP_lastday);
		$AMP_return['w'] = date("w",$AMP_lastday);
		$AMP_return['W'] = date("W",$AMP_lastday);
		
		return($AMP_return);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_dayrangebyweeknr                                               	 |
//| last modified: 02.06.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| returns in $AMP_dateformat the beginning and end date form a week-number in ISO-8601 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_dayrangebyweeknr'))
{
	function AMP_dayrangebyweeknr($AMP_weeknr, $AMP_year, $AMP_dateformat, $AMP_day)
	{
		$weekday = date("w",mktime(0,0,0,1,1,$AMP_year));
		$wbegin = 1;      
		if ($weekday > 4) { $wbegin = $weekday-$wbegin-1; } else { $wbegin = $wbegin-$weekday; }

		$days = ($AMP_weeknr-1)*7;
		$beginwn = mktime(0,0,0,1,1 + $wbegin + $days    ,$AMP_year);
		$endwn   = mktime(0,0,0,1,1 + $wbegin + $days +6 ,$AMP_year);

		settype($return, 'array');

		$return['start'] = date("$AMP_dateformat" , $beginwn);
		$return['end']   = date("$AMP_dateformat" , $endwn);

		$dayid = array("Mon"=>0, "Tue"=>1, "Wed"=>2, "Thu"=>3, "Fri"=>4, "Sat"=>5, "Sun"=>6);
		$day = $dayid[$AMP_day];
		
		$date = mktime(0,0,0,1,1+$wbegin+$days +$day ,$AMP_year);
		$return['day'] = date("$AMP_dateformat" , $date) ."<br>";

		return $return;
	}
}


//+----------------------------------------------------------------------------------------+
//| function : AMP_usercheck_admin                                                         |
//| last modified: 12.01.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| this function will proof the user                                                      |
//| If he logged in as a admin, AMP_usercheck_admin returns true                           |
//|                                                                                        |
//| string1 = name of the cookie                                                           |
//| string2 = table of user where session are stored                                       |
//| integer = id of the current open sql session                                           |
//|----------------------------------------------------------------------------------------|
//| AMP_check_adminlogin ( string1, string2, integer )                                     |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_usercheck_admin'))
{
	function AMP_usercheck_admin($AMP_cookiename, $AMP_tablename, $AMP_sqlconnect)
	{
	
		global $HTTP_COOKIE_VARS;
	
		if(isset($HTTP_COOKIE_VARS[$AMP_cookiename]))
		{
			$AMG_cookieuid = $HTTP_COOKIE_VARS[$AMP_cookiename];
			$AMG_query  = AMS_sql_query("SELECT * FROM $AMP_tablename WHERE user_session = '$AMG_cookieuid' AND user_status = '1'", $AMP_sqlconnect);
			$AMG_result = AMS_sql_fetch_array($AMG_query, $AMP_sqlconnect);
		}
		else
		{
			$AMG_result = false;
		}
		return $AMG_result;
	
	}
}
//+----------------------------------------------------------------------------------------+
//| function : AMP_usercheck_validuser                                                	   |
//| last modified: 27.01.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| this function will proof the user who want's to connect                                |
//| If the user logged in already, AMP_usercheck_validuser returns true                    |
//|                                                                                        |
//| string1 = name of the cookie                                                           |
//| string2 = table of user where session are stored                                       |
//| integer = id of the current open sql session                                           |
//|----------------------------------------------------------------------------------------|
//| AMP_check_userlogin ( string1, string2, integer )                                      |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_usercheck_validuser'))
{
	function AMP_usercheck_validuser($AMP_cookiename, $AMP_tablename, $AMP_sqlconnect)
	{
	
		global $HTTP_COOKIE_VARS;
	
		if(isset($HTTP_COOKIE_VARS[$AMP_cookiename]))
		{
			$AMG_cookieuid = $HTTP_COOKIE_VARS[$AMP_cookiename];
			$AMG_query  = AMS_sql_query("SELECT * FROM $AMP_tablename WHERE user_session = '$AMG_cookieuid' AND user_status = '2'", $AMP_sqlconnect);
			$AMG_result = AMS_sql_fetch_array($AMG_query, $AMP_sqlconnect);
		}
		else
		{
			$AMG_result = false;
		}
		return $AMG_result;
	
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_create_link	                                                 	 |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| stand alone link creation. Also included in AMP_build_bodyformat			 |
//| 											 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_create_link'))
{
	function AMP_create_link($AMG_new)
	{
		$AMG_pattern = '#(^|[^\"=]{1})(http://|ftp://|mailto:|news:)([^\s<>]+)([\s\n<>]|$)#sm';
		$AMG_new = preg_replace($AMG_pattern,"<a href=\"\\2\\3\" target=\"_blank\">\\2\\3</a>\\4",$AMG_new);
		
		return $AMG_new;
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_check_email                                                           |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| AMP_check_email examine the e-mail syntax                                            | 
//|											 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_check_email'))
{
	function AMP_check_email($AMP_email)
	{
		if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}$",$AMP_email)) {
	  		return false;
		} else {
			return true;
		}
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_create_smiliebar                                                 	 |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| Read smilie direcory and build the smiliebar in ./signin.php (if set in config)	 |
//| 											 |
//+--------------------------------------------------------------------------------------+


?>